#include "prefix.glsl"


#line 1

// Set this to 1 to view the raw font texture to view alignment.
#define DEBUG 0

#if VSHADER
	attribute	vec4		a_vertex;
	attribute	vec4		a_color;	
	attribute	vec2		a_texcoord0;
	#if BORDER
	attribute	vec4		a_texcoord1;
	#endif
#endif

	varying		vec4		v_color;
	varying		vec2		v_texcoord0;
	#if BORDER	
	varying		vec4		v_texcoord1;
	#endif

	uniform		sampler2D	u_tex;
	uniform		mat4		u_mvp_matrix;

#if VSHADER

void main()
{
	gl_Position = u_mvp_matrix * a_vertex;	
	v_texcoord0 = a_texcoord0;
	v_color = a_color;
	#if BORDER
	v_texcoord1 = a_texcoord1;
	#endif
}

#endif

#if FSHADER

void main()
{
	#if BORDER
		vec4	texel = texture2D(u_tex, v_texcoord0);		
		
		#if DEBUG
			gl_FragColor.rg = texel.rg;
			gl_FragColor.ba = vec2(0.0,1.0);
		
		#else
		
			float alpha_outline = texel.g * v_texcoord1.a;
			float alpha_main = texel.r * (1.0 - alpha_outline) * v_color.a;
			
			gl_FragColor.rgb = (v_color.rgb * alpha_main + v_texcoord1.rgb * alpha_outline);
			gl_FragColor.a = (alpha_outline + alpha_main);
		#endif
		
	#else
	
		float alpha = texture2D(u_tex, v_texcoord0).a * v_color.a;
		gl_FragColor = vec4(v_color.rgb, alpha);
		
	#endif
}

#endif










